normalize_plane_equation:
 movups xmm0,[plane_equation]    ;normalize
 movaps xmm1,xmm0
; andps  xmm0,[zero_hgst_dd]
 mulps  xmm0,xmm0
 haddps xmm0,xmm0
 haddps xmm0,xmm0
; shufps xmm0,xmm0,00000000b
 rsqrtps xmm0,xmm0
 mulps  xmm1,xmm0     ; xmm1 - normalized plane equat.
 movups [plane_equation],xmm1
ret
fill_aligned:
;in  eax - dword value to fill,
;    ecx - area size in dwords
;    edi - mem adress
;    addres must be aligned
    mov  ebx,ecx
    and  ebx,1111b  ;
    jz   .fill_sse
  @@:
    mov  [edi],eax
    add  edi,4
    sub  ebx,1
    jnz  @b
  .fill_sse:
    shr    ecx,4
    or     ecx,ecx
    jz     .end
    movd   xmm0,eax
    shufps xmm0,xmm0,0
    movaps xmm1,xmm0
    movaps xmm2,xmm0
    movaps xmm3,xmm0
    and    edi,-16 ; to be sure
  @@:
    movaps  [edi],xmm0
    movaps  [edi+16],xmm1
    movaps  [edi+32],xmm2
    movaps  [edi+48],xmm3
    add     edi,64
    sub     ecx,1
    jnz     @b
  .end:
ret
norm_aligned_lv:     ; normalise aligned light vectors
;  in edi -> lights_ptr
;     ecx -> lights count
    @@:
     movaps  xmm0,[edi]
     movaps  xmm1,[edi]
     mulps   xmm1,xmm1
     haddps  xmm1,xmm1
     haddps  xmm1,xmm1
     rsqrtps xmm1,xmm1
     mulps   xmm0,xmm1
     movaps  [edi],xmm0
     add     edi,64
     sub     ecx,1
     jnz     @b
ret