
draw_triangles_normals:
    push    ebp
    mov     ebp,esp
    sub     esp,50
    and     ebp,-16
  .scr_size equ [ebp-4]
  .up_res   equ [ebp-32]
 ;   movzx   eax,[xres_var]
 ;   movzx   ebx,[yres_var]
 ;   imul    eax,ebx
 ;   shl     eax,2
 ;   mov     .scr_size,eax
    movd    xmm4,[xres_vard]
    punpcklwd xmm4,[the_zero]
    pshufd  xmm4,xmm4,01000100b
    psubd   xmm4,[i4x4]
    movaps  .up_res,xmm4
    mov     ecx,[triangles_count_var]
    mov     ebx,[triangles_ptr]
    mov     edi,[triangles_normals_rotated_ptr]
    emms
  .next:
    push    ecx
    push    edi
    push    ebx
    mov     edx,dword[ebx]
    imul    edx,[i12]
    add     edx,[points_rotated_ptr]
    movups  xmm0,[edx]
    mov     edx,dword[ebx+4]
    imul    edx,[i12]
    add     edx,[points_rotated_ptr]
    movups  xmm1,[edx]
    mov     edx,dword[ebx+8]
    imul    edx,[i12]
    add     edx,[points_rotated_ptr]
    movups  xmm2,[edx]
    mov     edx,3
    cvtsi2ss  xmm3,edx
    addps   xmm0,xmm1
    addps   xmm0,xmm2
    shufps  xmm3,xmm3,0
    divps   xmm0,xmm3


    movups  xmm1,[edi]
    mov     eax,30.0
    movd    xmm3,eax
    pshufd  xmm3,xmm3,0
    mulps   xmm1,xmm3
    addps   xmm1,xmm0
    cvtps2dq xmm0,xmm0
    cvtps2dq xmm1,xmm1


    movdqa  xmm5,xmm0   ; is in screen area ?
    movlhps xmm5,xmm1
    movaps  xmm6,xmm5
    pcmpgtd xmm5,.up_res
    pcmpgtd xmm6,[i4x4]
    pxor    xmm5,xmm6
    movmskps eax,xmm5
    cmp     eax,00001111b
    jnz     @f

    movd    eax,xmm0
    movd    ecx,xmm1
    psrldq  xmm0,4
    psrldq  xmm1,4
    movd    ebx,xmm0
    movd    edx,xmm1
    mov     esi,0x0000ffff
    movd    mm3,esi
    movd    mm1,[screen_ptr]
    movzx   esi,word[xres_var]
    movd    mm2,esi
  ;  movd    mm4,.scr_size
    call    lineaa
  @@:
    pop     ebx
    pop     edi
 ;   pop     esi
    pop     ecx
    add     edi,12
    add     ebx,12
 ;   add     esi,12
    sub     ecx,1
    jnz     .next
    add     esp,50
    pop     ebp
ret
draw_vertices_normals:
    push   ebp
    mov    ebp,esp
    sub    esp,50
    and    ebp,-16

    .up_res equ [ebp-16]
    .norm_height equ [ebp-32]

    mov     ecx,[points_count_var]
    mov     edi,[points_normals_rotated_ptr]
    mov     esi,[points_rotated_ptr]
    mov     eax,30.0   ; lenght of normal vect
    movd    xmm1,eax
    pshufd  xmm1,xmm1,0
    movapd  .norm_height,xmm1
    movd    xmm4,[xres_vard]
    punpcklwd xmm4,[the_zero]
    pshufd  xmm4,xmm4,01000100b
    psubd   xmm4,[i4x4]
    movaps  .up_res,xmm4
  .again:
    push     esi
    push     edi
    push     ecx


    movups   xmm0,[edi]
    movups   xmm1,[esi]
    mulps    xmm0,.norm_height
    addps    xmm0,xmm1


    cvtps2dq xmm0,xmm0
    cvtps2dq xmm1,xmm1

    movdqa  xmm5,xmm0
    movlhps xmm5,xmm1
    movaps  xmm6,xmm5
    pcmpgtd xmm5,.up_res
    pcmpgtd xmm6,[i4x4]
    pxor    xmm5,xmm6
    movmskps eax,xmm5
    cmp     eax,00001111b
    jnz     @f

    movd    eax,xmm0
    movd    ecx,xmm1
    psrldq  xmm0,4
    psrldq  xmm1,4
    movd    ebx,xmm0
    movd    edx,xmm1
    mov     esi,0x0000ffff
    movd    mm3,esi
    movd    mm1,[screen_ptr]
    movzx   esi,word[xres_var]
    movd    mm2,esi
    call    lineaa
  @@:

    pop     ecx
    pop     edi
    pop     esi
    add     edi,12
    add     esi,12
    sub     ecx,1
    jnz     .again

    add     esp,50
    pop     ebp
ret

