Bdraw_all:
    .ptr  equ dword[ebp-8]

     push  ebp
     mov   ebp,esp
     sub   esp,64

     mov   ecx,BXRES * BYRES
     mov   eax,0xff1f1f1f
     mov   edi,Bbuffer
     call  fill_aligned


     mov   [global_points_counter],0

     fninit
     push  dword BXRES
     fild  word[Bix1_axis]
     fiadd dword[esp-4]
     fstp  dword[Bx1_axis]
     fild  [Biy1_axis]
     fstp  [By1_axis]
     mov   dword[Bz1_axis],0.0

     fild  word[Bix2_axis]
     fiadd dword[esp-4]
     fstp  dword[Bx2_axis]
     fild  [Biy2_axis]
     fstp  [By2_axis]
     mov   dword[Bz2_axis],0.0
     pop   eax

     mov   eax,[Bix1_axis]   
     mov   cl,253
     mov   esi,0x0000ffff
     pushad
     call  Bputpixel
     popad

     mov   eax,[Bix2_axis]
     mov   esi,0x0000ffff
     mov   cl,254
     pushad
     call  Bputpixel
     popad

     pushad
     movzx  eax,word[Bix1_axis]
     movzx  ebx,word[Biy1_axis]
     movzx  ecx,word[Bix2_axis]
     movzx  edx,word[Biy2_axis]
     emms
     mov    esi,BXRES
     movd   mm2,esi
 ;    mov    [screen_width_var],BXRES
 ;    mov    [lbuffer_ptr],Bbuffer
     mov    esi,Bbuffer
     movd   mm1,esi
     mov    esi,0x0000ff00
     movd   mm3,esi
     call   lineaa
     popad

     mov   esi,Biderives        ; draw derives -> lines
     mov   ecx,BSEGMENTS*2
  @@:
     pushad
     movzx  eax,word[esi]
     movzx  ebx,word[esi+2]
     movzx  ecx,word[esi+4]
     movzx  edx,word[esi+6]
   ;  mov    [screen_width_var],BXRES
     call   lineaa
     popad
     add    esi,8
     loop   @b


     mov  esi,Biderives
     xor  ecx,ecx                   ; draw red sqares
   @@:                              ; derives start and end
     mov  eax,dword[esi]
     pushad
     mov   esi,0x00ff0000
     call  Bputpixel
     popad
     add   esi,4
     inc   ecx
     cmp   ecx,BSEGMENTS*4 ;*3+1
     jnz   @b






     xor   edx,edx                  ; draw segments of bezier curves
     mov   esi,Biderives
     mov   .ptr,Bpoints
  .next_seg:
     push  edx
     xor   ebx,ebx
   @@:
     fninit
     fild  word[esi]
     fstp  [ebx+Bp1x]
     fild  word[esi+2]
     fstp  [ebx+Bp1y]
     mov   dword[ebx+Bp1z],0.0

     add   esi,4
     add   ebx,12
     cmp   ebx,48
     jnz   @b


     pushad
     mov      esi,.ptr
     call     draw_curve
   @@:

     popad
   ;000000000000  add    .ptr,BSTEPS * 12
     pop    edx
     add    edx,1
     cmp    edx,BSEGMENTS
     jnz   .next_seg

     mov    esp,ebp
     pop    ebp
ret
Bputpixel:
; in: eax - x + y shl 16
;     cl  - markup
;     esi - color 0x00rrggbb
  emms
  mov     ebx,(BYRES-5) shl 16 +BXRES-5
  movd    mm0,ebx
  mov     ebx,5 shl 16 +5
  movd    mm1,ebx
  movd    mm2,eax
  pmaxsw  mm2,mm1
  pminsw  mm2,mm0

  movd   eax,mm2
  mov    edx,BXRES
  movzx  ebx,ax
  shr    eax,16
  mul    edx
  add    eax,ebx
  shl    eax,2
  add    eax,Bbuffer

  mov     edi,eax              ; draw line handle
  and     esi,0x00ffffff
  mov     al,cl                ; cl -> crucial point number
  shl     eax,24
  or      eax,esi
;  cmp     cl,253
;  jae     .axis
;  or      eax,0x00ff0000
;  jmp     .draw
; .axis:
;  or      eax,0x0000ffff
; .draw:
  sub     edi,2*BXRES*4+20
  mov     ecx,5
  cld
  rep     stosd
  add     edi,BXRES*4-20
  mov     ecx,5
  rep     stosd
  add     edi,BXRES*4-20
  mov     ecx,5
  rep     stosd
  add     edi,BXRES*4-20
  mov     ecx,5
  rep     stosd
  add     edi,BXRES*4-20
  mov     ecx,5
  rep     stosd

  emms
ret
NextMdraw_all:

;in  eax - dword value to fill,
;    ecx - area size in dwords
;    edi - mem adress
;    addres must be aligned
     mov   ecx,BXRES * BYRES
     mov   eax,0xff1f1f1f
     mov   edi,Bbuffer
     call  fill_aligned

 ;    movq   xmm0,[NextMxadd]  ; x, y, z
 ;    packssdw xmm0,xmm0
;     psrlw   xmm0,1
;     mov     ebx,((BYRES shr 1) shl 16) + (BXRES shr 1)
;     movd    xmm1,ebx
;     paddusw xmm0,xmm1
     mov     eax,[NextMxadd]  ;xmm0
     mov     cl,1
     mov     esi,0x0000ffff
     call    Bputpixel  ; write bar on Bbuffer area
     mov     ax,[NextMzadd]
     shl     eax,16
     mov     ax,5
     mov     cl,2
     mov     esi,0x00ff00ff
     call    Bputpixel  ; write bar on Bbuffer area
     mov     ax,[NextScale]
     shl     eax,16
     mov     ax,(BXRES-10)
     mov     cl,3
     mov     esi,0x00ffff00
     call    Bputpixel  ; write bar on Bbuffer area


ret


Binit_derives:
   rdtsc
   mov  [rand_seed],ax
   mov  esi,Biderives
   mov  ecx,BSEGMENTS*4
 @@:
   push  ecx

   xor   ecx,ecx
   mov   edx,BXRES-1
   call  random
   mov   word[esi],ax

   xor   ecx,ecx
   mov   edx,BYRES-1
   call  random
   mov   word[esi+2],ax

   add   esi,4
   pop   ecx
   loop  @b
ret